﻿
using System;
using System.ComponentModel;
using System.Drawing;
using Wisej.Web;

namespace WisejWebApplication1 {
    public partial class Window1 : Form {

        /// <summary>
        /// System Events
        /// </summary>
        BindingList<SystemEvent> _activeEvents = new BindingList<SystemEvent>();

        /// <summary>
        /// Locak Object
        /// </summary>
        object _lockObject = new object();

        int _eventID = 1;

        public Window1() {

            InitializeComponent();
        }

        private void Window1_Load(object sender, EventArgs e) {

            dataGridView1.DataSource = _activeEvents;

        }

        private void timerUpdateTimes_Tick(object sender, EventArgs e) {

            lock (_lockObject) {

                foreach (var call in _activeEvents) call.CalculateTimes();

            };

        }

        private void buttonAddEvent_Click(object sender, EventArgs e) {

            var newSystemEvent = new SystemEvent(_eventID, $"Event {_eventID}");

            _activeEvents.Add(newSystemEvent);

            _eventID++;

        }

        private void dataGridView1_CellPaint(object sender, DataGridViewCellPaintEventArgs e) {

            if (e.RowIndex == -1) return;

            var currentRow = dataGridView1.Rows[e.RowIndex];

            var activeEvent = currentRow.DataBoundItem as SystemEvent;

            if (activeEvent != null) {

                var rect = new Rectangle(13, 4, 24, 24);

                var pen = new Pen(activeEvent.StatusColor);

                var brush = new SolidBrush(activeEvent.StatusColor);

                e.Graphics.DrawEllipse(pen, rect);

                e.Graphics.FillEllipse(brush, rect);

            }

        }

        private void buttonClearAllEvents_Click(object sender, EventArgs e) {


            lock (_lockObject) {

                _activeEvents.Clear();

            };

            _eventID = 1;


        }
    }
}
